pipeline {
    agent {
        label "10.88.231.24"
    }

    environment {
        GIT_COMMIT_SHORT = sh(
            script: "printf \$(git rev-parse --short ${GIT_COMMIT})",
            returnStdout: true
        )
        GIT_COMMIT_DATE = sh(
            script: "printf \$(git show -s --format=%ci ${GIT_COMMIT})",
            returnStdout: true
        )

        // ARTIFACT_REPOSITORY = "mothraaa/be:v2.0"
        CREDENTIAL_ID = "dockerhub"

        // BUILD_IMAGE = "be-nodejs:${GIT_COMMIT_DATE.take(10)}_${GIT_COMMIT_SHORT}"
        // DEPLOY_IMAGE = "${ARTIFACT_REPOSITORY}/${BUILD_IMAGE}"
    }

    stages {
        stage ("Validate") {
            steps {
                sh "docker version"
                sh "node --version"
                sh "npm version"
            }
        }

        stage ("Build docker image fe-angular") {
            steps {
                sh "docker build --pull --no-cache -f Dockerfile -t be:v2.0 ."
            }
        }

        stage ("Push docker image fe-angular to hub") {
            steps {
                withDockerRegistry([credentialsId: "${CREDENTIAL_ID}", url: "https://index.docker.io/v1/"]) {
                    sh "docker tag be:v2.0 mothraaa/be:v2.0"
                    sh "docker push mothraaa/be:v2.0"
                }
            }
        }
    }

    post {
        always {
            echo 'Cleaning up workspace'
            sh "docker rmi be:v2.0 || true"
            sh "docker rmi mothraaa/be:v2.0 || true"
            deleteDir() 
        }
    }
}